// ZoomASPX.h

#pragma once
#using <Mscorlib.dll>

#using <System.dll>
#using <System.Web.dll>
#include <vcclr.h>
#include "zoomsearch.h"
using namespace System;
using namespace System::IO;
using namespace System::Text;
using namespace System::Web;
using namespace System::Web::UI;
using namespace System::Collections;
using namespace System::Runtime::InteropServices;
using namespace System::Collections::Specialized;
//using namespace System::Security::Permissions;
using namespace System::Web::SessionState;

// gcroot macro to "pin" global mixed type data on the gc heap and static heap
// info from here: http://blogs.msdn.com/branbray/archive/2005/07/20/441099.aspx
//gcroot<HtmlTextWriter^> aspxoutput;

TIMER_VALUE starttime;
TIMER_VALUE endtime;
//char TempPrintfBuffer[MAX_PRINTF_BUFFERLEN+1];	// for zoomprintf()

namespace ZoomASPX {
	//[SecurityPermission(SecurityAction.Assert, Unrestricted = true)]	
	//[System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Assert, Unrestricted = true)]
	//[SessionState(SessionStateBehavior.Disabled)]
	//[SessionState(System.Web.SessionState.SessionStateBehavior.ReadOnly)]
    //[OutputCache(NoStore = true, Duration = 0, VaryByParam = "*")]
	public ref class ASPXSearch : System::Web::UI::WebControls::WebControl
	{		
		protected:
			
			 virtual void Render(HtmlTextWriter ^output) override
			 {												
				BOOL statusOK = TRUE;
				zoomSearch zs;
				zoomSearchSetup zsSetup;

				bIsPostBack = false;
				bIsPostBackParsed = false;

				zs.SetASPXOutput(output);
				//aspxoutput = output;
			
				
				/*
				//Allocate the buffer
				_buffer = (char*)malloc(OUT_BUFFER_SIZE*sizeof(char));

				if ( _buffer == NULL)
				{
					output->Write("Error: Memory Allocation Error");
					return;
				}
				*/


				//Deafult Values
				zsSetup.And = INPUT_RETRIEVE_ERROR;

				// default IP address
				strcpy(zsSetup.clientIP, "unknown");
				// try to determine actual IP address
				char* ipAddrStr = NULL;
				ipAddrStr = (char*)(void*)Marshal::StringToHGlobalAnsi(this->Page->Request->UserHostAddress);
				if (ipAddrStr != NULL)
				{
					if (strlen(ipAddrStr) > 0)
						strcpy(zsSetup.clientIP, ipAddrStr);
				}

				zsSetup.IsZoomQuery = false;
				zsSetup.NewSearch = 1;
				zsSetup.num_zoom_cats = 0;
				zsSetup.Page = 1;
				zsSetup.Per_Page = 10;
				strcpy((char*)zsSetup.Query, "");
				strcpy(zsSetup.ScriptName, "search.aspx");
				strcpy(zsSetup.ExeName, zsSetup.ScriptName);
				zsSetup.ShowXMLSettings = 0;
				zsSetup.Sort = 0;
				zsSetup.UseXML = INPUT_RETRIEVE_ERROR;
				zsSetup.DateFromStr[0] = '\0';
				zsSetup.DateToStr[0] = '\0';
				
				//Get path
				char* TmpPath = (char*)(void*)Marshal::StringToHGlobalAnsi(this->Page->Request->PhysicalPath);
				char* TmpScriptName = (strrchr(TmpPath, '\\')); //grab after last / or just take argv[0]
				if(TmpScriptName == NULL) //try looking for other /
					TmpScriptName = (strrchr(TmpPath, '/'));

				if(TmpScriptName == NULL)
				{
					strcpy(zsSetup.ScriptName, TmpPath);
					strcpy(zsSetup.ExecutePath, ".");	
				}
				else
				{
					strcpy(zsSetup.ScriptName, TmpScriptName+1);
					strcpy(zsSetup.ExecutePath, TmpPath);

					char* namePtr = strrchr(zsSetup.ExecutePath, '\\');
					if(namePtr == NULL) //look for /
						namePtr = strrchr(zsSetup.ExecutePath, '/');

					if(namePtr != NULL)
						*namePtr = '\0'; //remove filename
				}

				//output->Write("ScriptName = " + gcnew String(zsSetup.ScriptName)+"<br>");
				//output->Write("ExecutePath = " + gcnew String(zsSetup.ExecutePath)+"<br>");


				if (zs.setup1(&zsSetup) != SUCCESS)
				{
					//output->Write(gcnew String(_buffer));
					statusOK = FALSE;
				}

				if (zs.UseCats)
				{
					zsSetup.Cat = (int*) malloc(zs.NumCats * sizeof(int));
					if (zsSetup.Cat == NULL)
					{
						output->Write("Error: Memory Allocation Error");
						statusOK = FALSE;
					}
					cat_result_count=0;
				}
				if (zs.UseMetaFields)
				{
					zsSetup.meta_query = (char**) malloc(zs.NumMetaFields * sizeof(char*));
					if (zsSetup.meta_query == NULL)
					{
						output->Write("Error: Memory Allocation Error");
						statusOK = FALSE;
					}
					for (int fieldnum = 0; fieldnum < zs.NumMetaFields; fieldnum++)
					{
						zsSetup.meta_query[fieldnum] = (char*) malloc((METAFIELD_TEXT_LEN+1) * sizeof(char));	
						if (zsSetup.meta_query[fieldnum] == NULL)
						{
							output->Write("Error: Memory Allocation Error");
							statusOK = FALSE;
							break;
						}
						// must initialize to zero here for custom meta multiselect to work
						memset(zsSetup.meta_query[fieldnum], 0, sizeof(char)*(METAFIELD_TEXT_LEN+1));							
					}
					zsSetup.NumMetaFields = zs.NumMetaFields;
				}							

				if (statusOK == TRUE)
				{
					zs.InitQuery();

					// Retrieve HTTP POST parameters
					StreamReader^ responseStream = gcnew StreamReader(this->Page->Request->InputStream);
					String ^POSTquery = responseStream->ReadToEnd();
					
					//Get query string, split it, and read values
					String ^GETquery = this->Page->ClientQueryString;					

					if (POSTquery->Length > 0)
					{
						if (GETquery->Length > 0)
							GETquery = String::Concat(GETquery, '&');
						GETquery = String::Concat(GETquery, POSTquery);
					}

					array<String^>^ SplitQuery = GETquery->Split('&');
					IEnumerator^ SplitQueryEnum = SplitQuery->GetEnumerator();
					String^ tempString;
					String^ tempString2;
					
					while ( SplitQueryEnum->MoveNext() )
					{
						tempString = safe_cast<String^>(SplitQueryEnum->Current);

						array<String^>^ SplitValue = tempString->Split('=');
						IEnumerator^ SplitValueEnum = SplitValue->GetEnumerator();
						if ( SplitValueEnum->MoveNext() )
						{
							tempString = safe_cast<String^>(SplitValueEnum->Current);
							tempString = Web::HttpUtility::UrlDecode(tempString);

							if ( SplitValueEnum->MoveNext() )
							{
								tempString2 = safe_cast<String^>(SplitValueEnum->Current);
								tempString2 = Web::HttpUtility::UrlDecode(tempString2);
								RegisterInput(tempString, tempString2, &zs, &zsSetup);
							}
						}
					}
					
					if (zs.UseCats)
					{
						if(cat_result_count == 0)
							zsSetup.Cat[0] = -1;
						else
							zsSetup.num_zoom_cats = cat_result_count;
					}

					if(zsSetup.UseXML == INPUT_RETRIEVE_ERROR)
					{
						if (zs.DefaultToXML == 1)
							zsSetup.UseXML = 1;
						else
							zsSetup.UseXML = 0;
					}

					String^ contentType;
					if (zsSetup.UseXML)
						contentType = gcnew String("text/xml");
					else
						contentType = gcnew String("text/html");

					//No longer needed, charset set in aspx page ie. <%@Page ResponseEncoding="UTF-8"%>
					/*if (zs.NoCharset == 0)
					{
						//output->Write(contentType+"; charset="+gcnew String(zs.Charset));
						this->Page->ContentType = contentType+"; charset="+gcnew String(zs.Charset);
						//output->Write(contentType+"; charset=utf8");
						//this->Page->ContentType = contentType+"; charset=utf8";
					}
					else
					{
						//output->Write(contentType);
						this->Page->ContentType = contentType;
					}*/

					if (zsSetup.IsZoomAC)
					{
						//HttpResponse^ response = gcnew HttpResponse(this->Page->Response);						
						HttpResponse^ response = this->Page->Response;
						response->Clear();
						//Response.ContentType = "application/json; charset=utf-8";
						if (zs.LoadQuery(&zsSetup))
							zs.searchAC(&zsSetup);
						response->End();
					}
					else
					{
						if (zs.LoadQuery(&zsSetup))
							if (zs.OpenIndexFiles(&zsSetup) && zs.LoadDictionary(&zsSetup))
								zs.search(&zsSetup);		
					}

					/*
					String^ temp = gcnew String(_buffer, 0, strlen(_buffer), output->Encoding);
					output->Write(temp);
					*/

					// This call is necessary to force postback script to be available on the page
					if (zs.DotNetUsePostBacks == 1)
						this->Page->ClientScript->GetPostBackEventReference(this, "zoom_postback");
						//this->Page->GetPostBackEventReference(this);

				}

				//free(_buffer);
				output->Close();
			}
			

		private:
			

			Int32 cat_result_count;

			bool bIsPostBack;
			bool bIsPostBackParsed;

			void RegisterInput(String^ name, String^ value, zoomSearch* zs, zoomSearchSetup* zsSetup)
			{
				/*
				// We must not do this because we're skipping a blank query which is necessary for zoom_query=
				// to be recognized for a blank custom meta query.
				if (value->Length == 0)	
					return;
				*/
				
				// We do not parse any more parameters if we have successfully completed parsing in 
				// the postback. This is to avoid other parameters (e.g. specified/hidden in the <form>)
				// from overriding the parameters specified in the postback.
				if (bIsPostBack && bIsPostBackParsed)
					return;

				int parseVal = 0;

				if (name->CompareTo("zoom_xml") == 0)
				{					
					if (Int32::TryParse(value, parseVal))
						zsSetup->UseXML = parseVal;					
					return;
				}
				if (name->CompareTo("zoom_query") == 0)
				{
					//This would not work for non-ANSI search queries:
					//strcpy((char*)zsSetup->Query, (char*)(void*)Marshal::StringToHGlobalAnsi(value));		

					zsSetup->IsZoomQuery = true;	// We need to flag this here because an empty string is important and the following ignores it

					// We need to retrieve String from Managed code to Unmanaged code space. We can only get this
					// back in Unicode and then convert it back to the appropriate MB charset that the CGI code is expecting					
					WCHAR* queryWPtr = NULL;
					queryWPtr = (WCHAR*)Marshal::StringToHGlobalUni(value).ToPointer();
					if (queryWPtr != NULL)
					{
						int querylen = wcslen(queryWPtr);
						if (querylen < MAX_QUERY_LENGTH)
						{							
							memset(zsSetup->Query, 0, sizeof(char)*(MAX_QUERY_LENGTH+1));	
							if (zs->UseUTF8)
								WideCharToMultiByte(CP_UTF8, 0, queryWPtr, querylen, (char*)zsSetup->Query, MAX_QUERY_LENGTH, NULL, NULL);
							else
								WideCharToMultiByte(zs->Codepage, 0, queryWPtr, querylen, (char*)zsSetup->Query, MAX_QUERY_LENGTH, NULL, NULL);
						}
						Marshal::FreeHGlobal(IntPtr(queryWPtr));
					}
					return;
				}
				if (name->CompareTo("zoom_per_page") == 0)
				{
					if (Int32::TryParse(value, parseVal))
						zsSetup->Per_Page = parseVal;					
					return;
				}
				if (name->CompareTo("zoom_and") == 0)
				{
					if (Int32::TryParse(value, parseVal))
						zsSetup->And = parseVal;					
					return;
				}
				if (name->CompareTo("zoom_sort") == 0)
				{
					if (Int32::TryParse(value, parseVal))
						zsSetup->Sort = parseVal;					
					return;
				}
				if (name->CompareTo("zoom_page") == 0)
				{
					if (Int32::TryParse(value, parseVal))
						zsSetup->Page = parseVal;					
					return;
				}
				if (name->CompareTo("zoom_ac") == 0)
				{
					if (Int32::TryParse(value, parseVal))
						zsSetup->IsZoomAC = parseVal;					
					return;
				}
				if (name->CompareTo("zoom_datefrom") == 0)
				{
					// We need to retrieve String from Managed code to Unmanaged code space. We can only get this
					// back in Unicode and then convert it back to the appropriate MB charset that the CGI code is expecting					
					WCHAR* dateWPtr = NULL;
					dateWPtr = (WCHAR*)Marshal::StringToHGlobalUni(value).ToPointer();
					if (dateWPtr != NULL)
					{						
						memset(zsSetup->DateFromStr, 0, sizeof(char)*(DATESTRING_LENGTH+1));	
						if (zs->UseUTF8)
							WideCharToMultiByte(CP_UTF8, 0, dateWPtr, (int)wcslen(dateWPtr), (char*)zsSetup->DateFromStr, DATESTRING_LENGTH, NULL, NULL);
						else
							WideCharToMultiByte(zs->Codepage, 0, dateWPtr, (int)wcslen(dateWPtr), (char*)zsSetup->DateFromStr, DATESTRING_LENGTH, NULL, NULL);
						Marshal::FreeHGlobal(IntPtr(dateWPtr));
					}
					return;
				}
				if (name->CompareTo("zoom_dateto") == 0)
				{
					// We need to retrieve String from Managed code to Unmanaged code space. We can only get this
					// back in Unicode and then convert it back to the appropriate MB charset that the CGI code is expecting					
					WCHAR* dateWPtr = NULL;
					dateWPtr = (WCHAR*)Marshal::StringToHGlobalUni(value).ToPointer();
					if (dateWPtr != NULL)
					{						
						memset(zsSetup->DateToStr, 0, sizeof(char)*(DATESTRING_LENGTH+1));	
						if (zs->UseUTF8)
							WideCharToMultiByte(CP_UTF8, 0, dateWPtr, (int)wcslen(dateWPtr), (char*)zsSetup->DateToStr, DATESTRING_LENGTH, NULL, NULL);
						else
							WideCharToMultiByte(zs->Codepage, 0, dateWPtr, (int)wcslen(dateWPtr), (char*)zsSetup->DateToStr, DATESTRING_LENGTH, NULL, NULL);
						Marshal::FreeHGlobal(IntPtr(dateWPtr));
					}
					return;
				}
				
				if (name->CompareTo("masternode") == 0)
				{
					if (Int32::TryParse(value, parseVal))
						zsSetup->ShowXMLSettings = parseVal;
					return;
				}
				
				if (zs->UseCats)
				{
					if (name->CompareTo("zoom_cat[]") == 0)
					{
						if (cat_result_count < zs->NumCats)
						{
							if (Int32::TryParse(value, parseVal))
							{
								zsSetup->Cat[cat_result_count] = parseVal;
								if (zs->NumCats == 0 || zsSetup->Cat[cat_result_count] <= zs->NumCats)
									cat_result_count++;	// only keep this value (and not allow it to be overwritten) if under maxValue
							}
						}
						return;			
					}	
					else if (name->CompareTo("zoom_cat") == 0)
					{		
						if (Int32::TryParse(value, parseVal))
							zsSetup->Cat[0] = parseVal;
						cat_result_count = 1;						
						return;
					}
				}

				if (zs->UseMetaFields)
				{				
					for (int fieldnum = 0; fieldnum < zs->NumMetaFields; fieldnum++)
					{
						if (zs->metafields[fieldnum].type == METAFIELD_TYPE_MULTI)
						{
							// meta_query will store numeric values up to 255 per char
							// +1 for count at [0] index
							if (zsSetup->meta_query[fieldnum] != NULL)
							{
								char tmpMetaName[METAFIELD_NAME_LEN+1];
								strcpy(tmpMetaName, zs->metafields[fieldnum].name);
								strcat(tmpMetaName, "[]");							
								if (name->CompareTo(gcnew String(tmpMetaName)) == 0)
								{
									int paramNum = zsSetup->meta_query[fieldnum][0];

									// start at 1 since 0 holds the count
									if (Int32::TryParse(value, parseVal))
									{
										zsSetup->meta_query[fieldnum][paramNum+1] = (char)parseVal;						
									
										// increment the counter
										zsSetup->meta_query[fieldnum][0]++;
									}
								}
							}
						}
						else
						{
							// We need to check for both the plain meta name parameter and also the possible [] variation
							// for multi-select values.
							if (name->CompareTo(gcnew String(zs->metafields[fieldnum].name)) == 0)
							{
								if (zsSetup->meta_query[fieldnum] != NULL)
								{
									//This would not work for non-ANSI metafield queries:
									//strcpy((char*)zsSetup->meta_query[fieldnum], (char*)(void*)Marshal::StringToHGlobalAnsi(value));

									// We need to retrieve String from Managed code to Unmanaged code space. We can only get this
									// back in Unicode and then convert it back to the appropriate MB charset that the CGI code is expecting					
									WCHAR* queryWPtr = NULL;
									queryWPtr = (WCHAR*)Marshal::StringToHGlobalUni(value).ToPointer();
									if (queryWPtr != NULL)
									{						
										memset(zsSetup->meta_query[fieldnum], 0, sizeof(char)*(METAFIELD_TEXT_LEN+1));	
										if (zs->UseUTF8)
											WideCharToMultiByte(CP_UTF8, 0, queryWPtr, (int)wcslen(queryWPtr), (char*)zsSetup->meta_query[fieldnum], METAFIELD_TEXT_LEN, NULL, NULL);
										else
											WideCharToMultiByte(zs->Codepage, 0, queryWPtr, (int)wcslen(queryWPtr), (char*)zsSetup->meta_query[fieldnum], METAFIELD_TEXT_LEN, NULL, NULL);
										Marshal::FreeHGlobal(IntPtr(queryWPtr));
									}
								}
								break;
							}
						}
					}
				}

				if (name->CompareTo("__EVENTTARGET") == 0 && value->CompareTo("zoom_postback") == 0)
				{
					// This is our postback call!
					bIsPostBack = true;
				}

				if (name->CompareTo("__EVENTARGUMENT") == 0 && bIsPostBack)
				{
					// these are our postback arguments	
					
					if (value->Length > 0)
					{
						array<String^>^ SplitQuery = value->Split('&');
						IEnumerator^ SplitQueryEnum = SplitQuery->GetEnumerator();
						String^ tempString;
						String^ tempString2;
						
						while ( SplitQueryEnum->MoveNext() )
						{
							tempString = safe_cast<String^>(SplitQueryEnum->Current);

							array<String^>^ SplitValue = tempString->Split('=');
							IEnumerator^ SplitValueEnum = SplitValue->GetEnumerator();
							if ( SplitValueEnum->MoveNext() )
							{
								tempString = safe_cast<String^>(SplitValueEnum->Current);
								tempString = Web::HttpUtility::UrlDecode(tempString);

								// Do not allow to parse __EVENTARGUMENT parameter or we'll
								// potentially fall into an infinite loop (ok maybe not, but unnecessary nonetheless)
								if (tempString->CompareTo("__EVENTARGUMENT") != 0 && SplitValueEnum->MoveNext())
								{
									tempString2 = safe_cast<String^>(SplitValueEnum->Current);
									tempString2 = Web::HttpUtility::UrlDecode(tempString2);
									RegisterInput(tempString, tempString2, zs, zsSetup);
								}
							}
						}
						bIsPostBackParsed = true;
					}
				}

				return;
			}
	};
}
